<template>
  <div class="w-full lg:max-w-full lg:flex">
    <div
      class="h-48 lg:h-auto lg:w-48 flex-none bg-cover rounded-t lg:rounded-t-none lg:rounded-l text-center overflow-hidden"
      :style="`background-image: url('${image}')`"
      title="Mountain"
    ></div>
    <div
      class="w-full h-48 border-r border-b border-l border-gray-400 lg:border-l-0 lg:border-t lg:border-gray-400 bg-white rounded-b lg:rounded-b-none lg:rounded-r p-4 flex flex-col justify-between leading-normal"
    >
      <div class="mb-8">
        <router-link :to="`catalog/game/${idjeu}`">
          <div class="text-gray-900 font-bold text-xl mb-2 cursor-pointer">
            {{ name }}
          </div>
        </router-link>
        <p class="text-gray-700 text-base">
          {{ studio }}
        </p>
      </div>
      <div @click="deleteWish" class="flex justify-end">
        <font-awesome-icon icon="trash" />
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: "WishCard",
  props: {
    name: {
      type: String,
      default: ""
    },
    studio: {
      type: String,
      default: ""
    },
    id: {
      type: String,
      default: ""
    },
    idjeu: {
      type: Number,
      default: 0
    },
    image: {
      type: String,
      default:
        "https://cdn.radiofrance.fr/s3/cruiser-production/2020/12/0943738d-0301-4ddb-a8a7-c442e2bcccb0/1136_gettyimages-1164537342.jpg"
    }
  },
  inject: ["user", "createAlert"],
  data() {
    return {
      urlWish: `https://${window.location.hostname}:8443/wish/`
    }
  },
  methods: {
    deleteWish: function() {
      const headers = {
        Accept: "application/json",
        "Content-Type": "application/json",
        Authorization: "Bearer " + this.user.token
      }

      fetch(this.urlWish + this.id, {
        headers,
        method: "DELETE"
      })
        .then((res) => {
          if (res.ok) {
            this.$emit("delete")
          } else {
            throw new Error("Something went wrong")
          }
        })
        .catch(() => {
          this.createAlert({
            color: "red",
            text: "Une erreur est survenue",
            icon: "times"
          })
        })
    }
  }
}
</script>

<style scoped>
.card-image {
  background-image: url("");
}
</style>
